SystemOrganization addCategory: #'Magritte-XMLBinding'!
SystemOrganization addCategory: #'Magritte-XMLBinding-Test'!

MAVisitor subclass: #MXXmlReader
	instanceVariableNames: 'node object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

MXXmlReader subclass: #MXXmlAttributeReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlAttributeReader methodsFor: 'private' stamp: 'pmm 12/6/2006 12:50'!
childOf: aNode description: aDescription
	^aNode! !

!MXXmlAttributeReader methodsFor: 'private' stamp: 'pmm 12/5/2006 23:37'!
contentsFor: aDescription
	^self node attributeAt: aDescription xmlAttributeName! !

!MXXmlAttributeReader methodsFor: 'private' stamp: 'pmm 12/7/2006 18:23'!
epoch
	^TimeStamp
		year: 1970 month: 1 day: 1
		hour: 0 minute: 0 second: 0
		offset: (Duration seconds: 0)! !

!MXXmlAttributeReader methodsFor: 'visiting-description' stamp: 'pmm 12/5/2006 23:37'!
visitElementDescription: aDescription
	"This implementation can be very dangerous and might lead to a potential security hole, since the default implementation of #readFrom: in Object evaluates the expression to find its value. Most subclasses like Number, Date, Time, ... override this implementation, but some others (like Boolean) do not."

	| contents |
	contents := self contentsFor: aDescription.
	self object: (contents isNil ifFalse: [ aDescription kind readFrom: contents readStream ])! !

!MXXmlAttributeReader methodsFor: 'visiting-description' stamp: 'pmm 12/5/2006 23:37'!
visitStringDescription: aDescription
	self object: (self contentsFor: aDescription)! !

!MXXmlAttributeReader methodsFor: 'visiting-description' stamp: 'pmm 12/6/2006 17:07'!
visitTimeStampDescription: aDescription
	| contents |
	contents := self contentsFor: aDescription.
	self object: (contents isNil ifFalse: [
		| offset seconds |
		seconds := Integer readFrom: contents readStream.
		offset := Duration seconds: seconds.
		self epoch + offset ])! !

MXXmlAttributeReader subclass: #MXXmlElementAttributeReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlElementAttributeReader methodsFor: 'private' stamp: 'pmm 12/6/2006 17:15'!
childOf: aNode description: aDescription
	^aNode elementAt: aDescription xmlElementName! !

MXXmlReader subclass: #MXXmlElementReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlElementReader methodsFor: 'private' stamp: 'pmm 12/6/2006 12:51'!
childOf: aNode description: aDescription
	^aNode elementAt: aDescription xmlElementName! !

!MXXmlElementReader methodsFor: 'accessing' stamp: 'pmm 12/5/2006 22:58'!
contents
	^self node contentString! !

!MXXmlElementReader methodsFor: 'private' stamp: 'pmm 12/18/2006 17:07'!
stream
	^self contents readStream! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/16/2010 19:08'!
visitComposed: aDescription children: aCollection
	self object: (MXObject forElementNamed: self node name asString).
	(aCollection select: [:each|
		each isReadonly not]) do: [ :each |
		self object
			write: (each readXml: self node)
			using: each ]! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'pmm 12/6/2006 00:33'!
visitContainer: aDescription
	self visitComposed: aDescription children: aDescription children! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'pmm 12/5/2006 20:59'!
visitElementDescription: aDescription
	"This implementation can be very dangerous and might lead to a potential security hole, since the default implementation of #readFrom: in Object evaluates the expression to find its value. Most subclasses like Number, Date, Time, ... override this implementation, but some others (like Boolean) do not."

	self object: (aDescription kind readFrom: self stream)! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'pmm 12/5/2006 18:53'!
visitStringDescription: aDescription
	self object: self contents! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/17/2010 14:36'!
visitToManyRelationDescription: aDescription
	self object: (Array streamContents: [ :stream |
		self node elementsDo: [ :each |
			(each name = aDescription reference xmlElementName)
				ifTrue:  [ stream nextPut: (aDescription reference readXml: each) ] ] ])! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/17/2010 15:15'!
visitToOneRelationDescription: aDescription
	self object: (aDescription reference 
		readXml: (self node elementAt: aDescription reference xmlElementName))! !

!MXXmlElementReader methodsFor: 'visiting-description' stamp: 'pmm 3/17/2007 12:32'!
visitUrlDescription: aDescription
	self object: self contents unescapePercents! !

MXXmlElementReader subclass: #MXXmlIdentityReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlIdentityReader methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 13:00'!
childOf: aNode description: aDescription
	^aNode! !

MXXmlElementReader subclass: #MXXmlInlineElementReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlInlineElementReader methodsFor: 'private' stamp: 'pmm 12/6/2006 12:49'!
childOf: aNode description: aDescription
	^aNode! !

!MXXmlReader class methodsFor: 'instance creation' stamp: 'pmm 12/6/2006 12:47'!
read: aNode description: aDescription
	^ self new read: aNode description: aDescription! !

!MXXmlReader methodsFor: 'private' stamp: 'pmm 12/6/2006 12:48'!
childOf: aNode description: aDescription
	self subclassResponsibility! !

!MXXmlReader methodsFor: 'private' stamp: 'pmm 12/5/2006 22:57'!
error: aString
	MAReadError signal: aString! !

!MXXmlReader methodsFor: 'accessing' stamp: 'pmm 12/5/2006 22:57'!
node
	^node! !

!MXXmlReader methodsFor: 'accessing' stamp: 'pmm 12/5/2006 23:19'!
node: anObject
	node := anObject! !

!MXXmlReader methodsFor: 'accessing' stamp: 'pmm 12/5/2006 23:19'!
object
	^object! !

!MXXmlReader methodsFor: 'accessing' stamp: 'pmm 12/5/2006 23:19'!
object: anObject
	object := anObject! !

!MXXmlReader methodsFor: 'visiting' stamp: 'pmm 12/6/2006 13:01'!
read: aNode description: aDescription
	| child |
	child := self childOf: aNode description: aDescription.
	^child isNil ifFalse: [
		self
			node: child;
			visit: aDescription.
		self object ]! !

MAVisitor subclass: #MXXmlWriter
	instanceVariableNames: 'node object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

MXXmlWriter subclass: #MXXmlAttributeWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlAttributeWriter methodsFor: 'private' stamp: 'NorbertHartl 2/17/2010 06:04'!
targetNodeFor: anObject description: aDescription
	^ self node! !

!MXXmlAttributeWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/17/2010 06:37'!
visitStringDescription: aDescription
	(self targetNodeFor: self object description: aDescription) attributes 
		at: aDescription xmlAttributeName 
		put: (self object readUsing: aDescription) asString! !

MXXmlAttributeWriter subclass: #MXXmlElementAttributeWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlElementAttributeWriter methodsFor: 'private' stamp: 'NorbertHartl 2/17/2010 06:32'!
targetNodeFor: anObject description: aDescription
	| targetNode |
	targetNode := XMLElement new name: aDescription xmlElementName.
	self node addElement: targetNode.
	^ targetNode! !

MXXmlWriter subclass: #MXXmlElementWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlElementWriter methodsFor: 'private' stamp: 'NorbertHartl 2/17/2010 06:32'!
targetNodeFor: anObject description: aDescription
	| targetNode |
	targetNode := XMLElement new name: aDescription xmlElementName.
	self node addElement: targetNode.
	^ targetNode! !

!MXXmlElementWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/17/2010 12:23'!
visitContainer: aDescription
	"prepare new element for new object to be written. Only instance variables not being nil are written"
	node := XMLElement new name: aDescription xmlElementName.
	aDescription children do: [:each|
		(self object readUsing: aDescription) ifNotNil: [
			each xmlWriter new 
				object: self object;
				node: self node;
				visit: each
			]
	]! !

!MXXmlElementWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/17/2010 06:31'!
visitStringDescription: aDescription
	(self object readUsing: aDescription) ifNotNil: [:string|
		(self targetNodeFor: self object description: aDescription)
			addContent: (XMLStringNode string: string asString)]! !

!MXXmlElementWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/17/2010 12:31'!
visitToManyRelationDescription: aDescription
	| child |
	child := self targetNodeFor: self object description: aDescription.
	(self object readUsing: aDescription) do: [:each|
		child addElement: (aDescription xmlWriter 
			write: each 
			description: aDescription reference)]! !

!MXXmlElementWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/17/2010 12:33'!
visitToOneRelationDescription: aDescription
	(self targetNodeFor: self object description: aDescription) addElement: (aDescription xmlWriter 
			write: (self object readUsing: aDescription) 
			description: aDescription reference)! !

MXXmlElementWriter subclass: #MXXmlInlineElementWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlInlineElementWriter methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 12:32'!
targetNodeFor: anObject description: aDescription
	^ self node! !

!MXXmlWriter class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 12:29'!
write: anObject description: aDescription
	^ self new write: anObject description: aDescription! !

!MXXmlWriter methodsFor: 'accessing' stamp: 'NorbertHartl 2/15/2010 15:01'!
node
	^ node! !

!MXXmlWriter methodsFor: 'accessing' stamp: 'NorbertHartl 2/15/2010 15:01'!
node: aNode
	node := aNode! !

!MXXmlWriter methodsFor: 'accessing' stamp: 'NorbertHartl 2/15/2010 15:01'!
object
	^ object! !

!MXXmlWriter methodsFor: 'accessing' stamp: 'NorbertHartl 2/15/2010 15:01'!
object: anObject
	object := anObject! !

!MXXmlWriter methodsFor: 'private' stamp: 'NorbertHartl 2/17/2010 06:26'!
targetNodeFor: anObject description: aDescription
	self subclassResponsibility! !

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/16/2010 00:52'!
visitNumberDescription: aDescription
	self visitStringDescription: aDescription
	! !

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/17/2010 05:57'!
write: anObject description: aDescription
	self 
		object: anObject;
		visit: aDescription.
	^ self node		! !

!MAContainer class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/17/2010 14:39'!
defaultXmlReader
	^ MXXmlInlineElementReader! !

!MAToOneRelationDescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/17/2010 13:48'!
defaultXmlReader
	^ MXXmlInlineElementReader! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/16/2010 00:03'!
defaultXmlReader
	^ MXXmlElementReader ! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/15/2010 17:38'!
defaultXmlWriter
	^MXXmlElementWriter ! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 18:42'!
descriptionXmlElementName
	^(MAStringDescription selector: #xmlElementName label: 'XML Element Name' priority: 1000)! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/15/2010 23:43'!
descriptionXmlReader
	^ (MASingleOptionDescription selector: #xmlReader label: 'XML Reader' priority: 1300 default: self defaultXmlReader)
		reference: MAClassDescription new;
		options: (Array
			with: MXXmlElementReader
			with: MXXmlAttributeReader
			with: MXXmlInlineElementReader
			with: MXXmlElementAttributeReader);
		yourself ! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/15/2010 22:26'!
fromXml: aString
	"Answer an object being parsed from <code>aString</code>."

	^ self fromXml: aString reader: self xmlReader! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/17/2010 14:40'!
fromXml: aString reader: aParser
	"Answer an object being parsed from <code>aNode</code> using <code>aParser</code>."

	^ aParser
		read: (XMLDOMParser parseDocumentFrom: aString readStream) elements first
		description: self! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 13:15'!
readXml: aNode
	"Answer an object being parsed from <code>aString</code>."

	^ self xmlReader read: aNode description: self! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 20:17'!
xmlElementName
	^self
		propertyAt: #xmlElementName
		ifAbsent: [ self accessor selector asString ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 20:16'!
xmlElementName: aString
	self propertyAt: #xmlElementName put: aString! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 20:16'!
xmlReader
	"Answer a Visitor that can be used to parse the model described by the receiver from a DOM node."

	^ self propertyAt: #xmlReader ifAbsent: [ self class defaultXmlReader ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 20:16'!
xmlReader: aClass
	self propertyAt: #xmlReader put: aClass! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/15/2010 12:49'!
xmlWriter
	

	^ self propertyAt: #xmlWriter ifAbsent: [ self class defaultXmlWriter ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/15/2010 12:50'!
xmlWriter: aClass
	self propertyAt: #xmlWriter put: aClass! !

!MAElementDescription class methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 00:18'!
descriptionXmlAttributeName
	^(MAStringDescription selector: #xmlAttributeName label: 'XML Attribute Name' priority: 1100)! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 00:18'!
xmlAttributeName
	^self
		propertyAt: #xmlAttributeName
		ifAbsent: [ self accessor selector asString ]! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 00:18'!
xmlAttributeName: aString
	self propertyAt: #xmlAttributeName put: aString! !

!MARelationDescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 3/17/2007 15:41'!
xmlElementName
	^self
		propertyAt: #xmlElementName
		ifAbsent: [ self reference xmlElementName ]! !

TestCase subclass: #MXXMLBindingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXXMLBindingTest methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 09:04'!
findTitle: aString in: aCollection
	^ (aCollection 
		detect: [:each| each title = aString]
		ifNone: [ nil ]) notNil! !

!MXXMLBindingTest methodsFor: 'fixtures' stamp: 'NorbertHartl 2/17/2010 13:37'!
onoToMany
	^ MXOneToManySource new
		label: 'A label';
		targets: (
			OrderedCollection new
				add:(MXRelationTarget new
					title: 'title1');
				add:(MXRelationTarget new
					title: 'title2');
				add:(MXRelationTarget new
					title: 'title3');
				yourself
			);
		inlineTargets: (
			OrderedCollection new
				add:(MXRelationInlineTarget new
					title: 'inline title1');
				add:(MXRelationInlineTarget new
					title: 'inline title2');
				add:(MXRelationInlineTarget new
					title: 'inline title3');
				yourself
			)! !

!MXXMLBindingTest methodsFor: 'fixtures' stamp: 'NorbertHartl 2/17/2010 13:37'!
onoToOne
	^ MXOneToOneSource new
		label: 'A label';
		target: (
			MXRelationTarget new
				title: 'A title');
		inlineTarget: (
			MXRelationInlineTarget new
				title: 'An inline title')! !

!MXXMLBindingTest methodsFor: 'fixtures' stamp: 'NorbertHartl 2/17/2010 05:39'!
simpleObject
	^ MXSimpleObject new
		title: 'A title';
		abstract: 'A longer text as abstract';
		token: 'article';
		index: 100000 atRandom;
		date: Date today! !

!MXXMLBindingTest methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 15:01'!
testOneToManyRoundtrip
	| object xmlString created |
	object := self onoToMany.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	
	created := MXOneToManySource fromXml: xmlString.
	self assert: object label = created label.
	self assert: created targets notEmpty.
	self assert: object targets size = created targets size.
	self assert: (self findTitle: 'title1' in: created targets).
	self assert: (self findTitle: 'title2' in: created targets).
	self assert: (self findTitle: 'title3' in: created targets).
	self assert: created inlineTargets notEmpty.
	self assert: (self findTitle: 'inline title1' in: created inlineTargets).
	self assert: (self findTitle: 'inline title2' in: created inlineTargets).
	self assert: (self findTitle: 'inline title3' in: created inlineTargets).
! !

!MXXMLBindingTest methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 13:21'!
testOneToOneRoundtrip
	| object xmlString created |
	object := self onoToOne.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	xmlString inspect.
	created := MXOneToOneSource fromXml: xmlString.
	self assert: object label = created label.
	self assert: created target notNil.
	self assert: object target title = created target title.
	self assert: object inlineTarget title = created inlineTarget title.
! !

!MXXMLBindingTest methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 10:02'!
testSimpleRoundtrip
	| object xmlString created |
	object := self simpleObject.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	created := MXSimpleObject fromXml: xmlString.
	self assert: object title = created title.
	self assert: object index = created index.
	self assert: object abstract = created abstract.
	self assert: object token = created token! !

Object subclass: #MXObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXObject class methodsFor: 'accessing-description' stamp: 'NorbertHartl 2/15/2010 11:27'!
descriptionContainer
	^super descriptionContainer
		xmlElementName: self xmlElementName;
		yourself! !

!MXObject class methodsFor: 'accessing' stamp: 'NorbertHartl 2/15/2010 11:27'!
forElementNamed: aString
	self withAllConcreteClassesDo: [ :each |
		(each xmlElementName = aString)
			ifTrue: [ ^each new ] ].
	self error: 'unknown element name: ', aString! !

!MXObject class methodsFor: 'instance creation' stamp: 'NorbertHartl 2/15/2010 11:27'!
fromXml: aString
	^self description fromXml: aString! !

!MXObject class methodsFor: 'testing' stamp: 'NorbertHartl 2/15/2010 11:27'!
isAbstract
	^ true! !

!MXObject class methodsFor: 'reflection' stamp: 'NorbertHartl 2/15/2010 11:27'!
withAllConcreteClasses
	^Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ]! !

!MXObject class methodsFor: 'reflection' stamp: 'NorbertHartl 2/15/2010 11:27'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [
			aBlock value: each ] ]! !

!MXObject class methodsFor: 'accessing' stamp: 'NorbertHartl 2/15/2010 11:27'!
xmlElementName
	self subclassResponsibility ! !

!MXObject methodsFor: 'printing' stamp: 'NorbertHartl 2/16/2010 00:15'!
printXMLOn: aStream
	self toXml printXMLOn: (XMLWriter on: aStream)! !

!MXObject methodsFor: 'converting' stamp: 'NorbertHartl 2/16/2010 00:15'!
toXml
	^ self description xmlWriter 
		write: self 
		description: self description! !

MXObject subclass: #MXOneToManySource
	instanceVariableNames: 'label targets inlineTargets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXOneToManySource class methodsFor: 'description' stamp: 'NorbertHartl 2/17/2010 12:32'!
descriptionInlineTargets
	^(MAToManyRelationDescription new 
		accessor: #inlineTargets; 
		label: '1:m inline targets'; 
		priority: 600)
		reference: MXRelationTarget description;
		xmlWriter: MXXmlInlineElementWriter;
		xmlReader: MXXmlInlineElementReader;
		xmlElementName: 'itargets';
		yourself! !

!MXOneToManySource class methodsFor: 'description' stamp: 'NorbertHartl 2/17/2010 06:54'!
descriptionLabel
	^ MAStringDescription new
		accessor: #label;
		priority: 100;
		label: 'Label';
		xmlReader: MXXmlAttributeReader;
		xmlWriter: MXXmlAttributeWriter;
		yourself! !

!MXOneToManySource class methodsFor: 'description' stamp: 'NorbertHartl 2/17/2010 08:23'!
descriptionTargets
	^(MAToManyRelationDescription new 
		accessor: #targets; 
		label: '1:m targets'; 
		priority: 600)
		reference: MXRelationTarget description;
		xmlWriter: MXXmlElementWriter;
		xmlReader: MXXmlElementReader;
		xmlElementName: 'ftargets';
		yourself! !

!MXOneToManySource class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 06:54'!
isAbstract
	^ false! !

!MXOneToManySource class methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 07:02'!
xmlElementName
	^ 'onoToManySource'! !

!MXOneToManySource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 08:59'!
inlineTargets
	^ inlineTargets! !

!MXOneToManySource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 08:59'!
inlineTargets: aCollection
	inlineTargets := aCollection! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
label
	^ label! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
label: aString
	label := aString! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
targets
	^ targets! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
targets: aCollection
	targets := aCollection! !

MXObject subclass: #MXOneToOneSource
	instanceVariableNames: 'label target inlineTarget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXOneToOneSource class methodsFor: 'description' stamp: 'NorbertHartl 2/17/2010 12:34'!
descriptionInlineTarget
	^(MAToOneRelationDescription new 
		accessor: #inlineTarget; 
		label: '1:1 inline target'; 
		priority: 600)
		xmlElementName: 'inlinetarget';
		xmlReader: MXXmlInlineElementReader;
		xmlWriter: MXXmlInlineElementWriter;
		reference: MXRelationTarget description;
		yourself! !

!MXOneToOneSource class methodsFor: 'description' stamp: 'NorbertHartl 2/17/2010 06:43'!
descriptionLabel
	^ MAStringDescription new
		accessor: #label;
		priority: 100;
		label: 'Label';
		xmlReader: MXXmlAttributeReader;
		xmlWriter: MXXmlAttributeWriter;
		yourself! !

!MXOneToOneSource class methodsFor: 'description' stamp: 'NorbertHartl 2/17/2010 07:51'!
descriptionTarget
	^(MAToOneRelationDescription new 
		accessor: #target; 
		label: '1:1 target'; 
		priority: 600)
		xmlElementName: 'target';
		xmlReader: MXXmlElementReader;
		xmlWriter: MXXmlElementWriter;
		reference: MXRelationTarget description;
		yourself! !

!MXOneToOneSource class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 06:51'!
isAbstract
	^ false! !

!MXOneToOneSource class methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:48'!
xmlElementName
	^ 'onoToOneSource'! !

!MXOneToOneSource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 08:35'!
inlineTarget
	^ inlineTarget! !

!MXOneToOneSource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 08:36'!
inlineTarget: anObject
	inlineTarget := anObject! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:43'!
label
	^ label! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:42'!
label: aString
	label := aString! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:45'!
target
	^ target! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:44'!
target: anObject
	target := anObject! !

MXObject subclass: #MXRelationInlineTarget
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXRelationInlineTarget class methodsFor: 'description' stamp: 'NorbertHartl 2/17/2010 13:36'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		xmlReader: MXXmlAttributeReader;
		xmlWriter: MXXmlAttributeWriter;
		yourself! !

!MXRelationInlineTarget class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 13:36'!
isAbstract
	^ false! !

!MXRelationInlineTarget class methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 13:36'!
xmlElementName
	^ 'inlineTarget'! !

!MXRelationInlineTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 13:36'!
title
	^ title! !

!MXRelationInlineTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 13:36'!
title: aString
	title := aString! !

MXObject subclass: #MXRelationTarget
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXRelationTarget class methodsFor: 'description' stamp: 'NorbertHartl 2/17/2010 06:42'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		xmlReader: MXXmlAttributeReader;
		xmlWriter: MXXmlAttributeWriter;
		yourself! !

!MXRelationTarget class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 06:51'!
isAbstract
	^ false! !

!MXRelationTarget class methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:48'!
xmlElementName
	^ 'oneToOneTarget'! !

!MXRelationTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:42'!
title
	^ title! !

!MXRelationTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:42'!
title: aString
	title := aString! !

MXObject subclass: #MXSimpleObject
	instanceVariableNames: 'title abstract token index date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXSimpleObject class methodsFor: 'description' stamp: 'NorbertHartl 2/17/2010 05:26'!
descriptionAbstract
	^ MAStringDescription new
		accessor: #abstract;
		priority: 150;
		label: 'Abstract';
		xmlReader: MXXmlElementReader;
		xmlWriter: MXXmlElementWriter;
		yourself! !

!MXSimpleObject class methodsFor: 'description' stamp: 'NorbertHartl 2/17/2010 05:21'!
descriptionIndex
	^ MANumberDescription new
		accessor: #index;
		priority: 200;
		label: 'Index';
		xmlReader: MXXmlAttributeReader;
		xmlWriter: MXXmlAttributeWriter;
		yourself! !

!MXSimpleObject class methodsFor: 'description' stamp: 'NorbertHartl 2/17/2010 05:21'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		xmlReader: MXXmlAttributeReader;
		xmlWriter: MXXmlAttributeWriter;
		yourself! !

!MXSimpleObject class methodsFor: 'description' stamp: 'NorbertHartl 2/17/2010 06:32'!
descriptionToken
	^ MAStringDescription new
		accessor: #token;
		priority: 180;
		label: 'Title';
		xmlReader: MXXmlElementAttributeReader;
		xmlWriter: MXXmlElementAttributeWriter;
		xmlAttributeName: 'type';
		yourself! !

!MXSimpleObject class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 05:20'!
isAbstract
	^ false! !

!MXSimpleObject class methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:18'!
xmlElementName
	^ 'simpleobject'! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:26'!
abstract
	^ abstract! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:26'!
abstract: aString
	abstract := aString! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
date
	^ date! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
date: aDate
	date := aDate! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
index
	^ index! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
index: aNumber
	index := aNumber! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
title
	^ title! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:11'!
title: aString
	title := aString! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:36'!
token
	^ token! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:37'!
token: aString
	token := aString! !

!MAToManyRelationDescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/16/2010 00:04'!
defaultXmlReader
	^ MXXmlInlineElementReader! !

!MAToManyRelationDescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/17/2010 13:10'!
defaultXmlWriter
	^ MXXmlInlineElementWriter! !
